=begin
(c) TIG 2009

  export_selection.rb
  
Usage: export_selection(type)
Exports everything in the selection, the argument 'type' sets the file type...
Faces with unselected Edges take those Edges with them...
e.g. export_selection('obj')

### load"export_by_layer.rb"

=end
require 'sketchup.rb'
def export_selection(type)
  model=Sketchup.active_model
  entities=model.entities
  defns=model.definitions
  ss=model.selection
  modelpath=File.dirname(model.path)
  modeltitle=model.title
  if modelpath==""
    puts "Model has not been saved..."
    return nil
  end#if
  if not ss[0]
    puts "Nothing selected..."
    return nil
  end#if
    model.start_operation("Export Selection")
    ssa=ss.to_a
    edges=[]
    ssa.each{|face|face.edges.each{|e|edges<<e if not ssa.include?(e)}if face.class==Sketchup::Face}
    ssa=ssa+edges ### add faces edges if ot selected
    group=entities.add_group(ssa)
    xentities=entities.to_a-[group]
    xentities.each{|e|e.erase! if e.valid?}
    defns.each{|defn|defn.entities.each{|e|e.erase! if e.valid?}if not defn.instances}
    ### purge unselected compos
    model.commit_operation
    model.export(modelpath+"/"+modeltitle+"_Part_."+type,false)### exporter
    Sketchup.undo ### undeletes stuff ?
end#def
###